<template>
  <div class="wallet-index-page">
    <client-only>
      <div class="links">
        <a
          @click.prevent="callSigner"
          href="#"
          target="_blank"
          class="button--green"
        >
          {{ loginButtonText }}
          {{ Balance }}
        </a>
      </div>




      <div class="links">
        <a
          @click.prevent="balance"
          href="#"
          target="_blank"
          class="button--green"
        >
          {{ Balance }}
        </a>
      </div>


    <div class="row">
        <button class="button" @click="SendTransfer()">
            Send Transfer
        </button>
    </div>



    </client-only>
    <!--div class="test__row">
      <button v-if="!address" class="test__button" @click="testLogin()">
        Authorization
      </button>
      <div v-else>
        <p>
          authorized as <br />
          {{ address }}
        </p>
        <a
          :href="`https://wavesexplorer.com/testnet/address/${address}`"
          target="_blank"
          >Check the Explorer</a
        >
      </div>
    </div-->

    <BuyTokens />
    <Transactions :where="{}" />
    <!--<div class="wallet-field">
      <div class="col-4">
        <Input label="ULUS to buy" icon="L" type="text" placeholder="0" />
      </div>
      <div class="col-8">
        <div class="wallet-input">
          <div class="wallet-input__label">
            Exchange rate

            <el-tooltip
              effect="ulu"
              placement="top"
              content="Live update from coinmarketcap.com"
            >
              <span>i</span>
            </el-tooltip>
          </div>
          <div>
            <div class="wallet-input__info">
              <div><span>$</span>120</div>
              <div><span>BTC</span>0000.35456</div>
              <div><span>ETH</span>0.35</div>
            </div>
          </div>
        </div>
      </div>
    </div>
    -->

    <!--<div class="wallet-field">
      <div class="col-6">
      <Select
          label="PAYMENT TYPE"
          :options="[
            'Add bank card',
            'MasterCard ****7366',
            'Bitcoin',
            'Ethereum'
          ]"
          :default="'MasterCard ****7366'"
          @click="OpenModal('Add card')"
        />
      </div>
      <div class="col-6">
        <Button
          styles="size-3 style-3 btn-flex"
          icon="arrow-line"
          @click="OpenModal('Purchase')"
        >
          Purchase tokens
        </Button>
      </div>
    </div>

    <History>
      <HistoryItem
        v-for="(item, itemKey) in historys"
        :key="itemKey"
        :content="item"
      />
    </History>-->
  </div>
</template>

<script lang="ts">
import { defineComponent, useContext, ref } from '@nuxtjs/composition-api'

import elTooltip from '@/components/element/Tooltip.vue'

import Button from '@/components/ui/Button.vue'

import Transactions from '@/components/profile/wallet/Transactions.vue'
import Transaction from '@/components/profile/wallet/Transaction.vue'

import BuyTokens from '@/components/profile/wallet/BuyTokens.vue'

import { Signer } from '@waves/signer'
import { ProviderWeb } from '@waves.exchange/provider-web'

const signer = new Signer({
  // Specify URL of the node on Testnet
  NODE_URL: 'https://nodes-testnet.wavesnodes.com'
})

// setting the Waves.Exchange provider
const provider = new ProviderWeb('https://testnet.waves.exchange/signer/')
signer.setProvider(provider)
//signer.setProvider(new ProviderWeb('https://testnet.waves.exchange/signer/'))

export default defineComponent({
  name: 'WalletIndexPage',
  components: {
    Button,
    Transactions,
    Transaction,
    elTooltip,
    BuyTokens
  },
  data() {
    return {
      loginButtonText: 'login',
      isAuthenticated: false,
      Balance: 'Balance'
    }
  },
  methods: {
    async callSigner() {
      if (!this.isAuthenticated) {
        this.loginButtonText = 'logging in...'

        try {
          const userData = await signer.login()

          this.loginButtonText = `Signed in as ${userData.address}`

          this.isAuthenticated = true

          const balances = await signer.getBalance()

          this.Balance=`Balance ${balances[0]['amount']}`
        } catch (error) {
          this.loginButtonText = error.message
        }
      } else {
        try {
          await signer.logout()

          this.isAuthenticated = false

          this.loginButtonText = 'Login'
        } catch (error) {
          this.loginButtonText = error.message
        }
      }
    },

        async balance() {
          this.Balance = '..'
          try {

            const balances = await signer.getBalance()

            this.Balance=`Balance ${balances[0]['amount']}`

          } catch (error) {
            this.Balance = 'Необходимо авторизоваться.'
          }

        },

        async SendTransfer() {

          try {

            let transferData = {
                recipient: "3MuN7D8r19zdvSpAd1L91Gs88bcgwUFy2mn",
                amount: 1
            }

            const transfer = await signer
                                  .transfer(transferData)
                                  .broadcast();

          } catch (error) {

          }        

        }        





  }
})
</script>

<style lang="scss" scoped></style>
